<?php

namespace FM\Controller;

use FM\Controller\FMCrud;
use FM\Service\ServicosService;
use FM\Traits\TResponse;

class ServicosController extends FMCrud
{

    use TResponse;

    protected $ServicosService;

    public function __construct($crudService, $environment, ServicosService $ServicosService)
    {
        parent::__construct($crudService, $environment);
        $this->ServicosService = $ServicosService;
    }
    
    public function getInformacoesServico()
    {
        try {
            $data = $this->ServicosService->getInformacoesServico();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
}
